import { defineComponent as s, watch as f, h as t, Teleport as c, Transition as m } from "vue";
import { _ as r } from "./Shadow.vue_vue_type_script_setup_true_lang-B3BOJC7S.js";
import { _ as n } from "./Button.vue_vue_type_script_setup_true_lang-CotO76QS.js";
import { _ as h } from "./Close.vue_vue_type_script_setup_true_lang-BCc-M9sH.js";
const k = s({
  props: {
    /** 控制遮罩展现，是否显示遮罩 */
    mask: {
      type: Boolean,
      default: !0
    },
    /** 是否可以通过点击 mask 关闭对话框 */
    maskClosable: {
      type: Boolean,
      default: !0
    },
    /** 是否显示对话框 */
    modelValue: {
      type: Boolean,
      default: !1,
      required: !0
    },
    /** Dialog 对话框 Dialog 的标题， 也可通过具名 slot （见下表）传入
     * 如果都不传，则不显示标题
     */
    title: String,
    /** 是否显示右上角关闭按钮, 1 - 显示在框内， 2 - 显示在框角, 0 - 不显示 */
    showClose: {
      type: Number,
      default: 1
    },
    /** 是否显示底部取消按钮 */
    showCancel: {
      type: Boolean,
      default: !0
    },
    /** 是否显示底部确定按钮 */
    showOk: {
      type: Boolean,
      default: !0
    },
    /** 主体样式 */
    mainClass: {
      type: String,
      default: ""
    },
    /** 内容区域样式 */
    containerClass: {
      type: String,
      default: ""
    },
    /** 是否水平垂直对齐对话框 */
    alignCenter: {
      type: Boolean,
      default: !1
    },
    /** 关闭前的回调, 会暂停 Dialog 的关闭. */
    beforeClose: {
      type: Function,
      default: void 0
    },
    /** 对话框宽度 */
    width: {
      type: String,
      default: void 0
    },
    to: {
      type: [Object, String],
      default: "body"
    },
    /** 主题, normal - 普通, mobile - 移动风格 */
    theme: {
      type: String,
      default: "normal"
    }
  },
  emits: ["update:modelValue"],
  setup(e, { slots: a, emit: d }) {
    e.modelValue === !0 && document.body.classList.add("nt-body-lock"), f(
      () => e.modelValue,
      (l) => {
        l === !0 ? document.body.classList.add("nt-body-lock") : document.body.classList.remove("nt-body-lock");
      }
    );
    function i() {
      e.mask && e.maskClosable && o("close");
    }
    function u() {
      d("update:modelValue", !1);
    }
    function o(l) {
      e.beforeClose == null ? d("update:modelValue", !1) : e.beforeClose(l, u);
    }
    return () => t(
      c,
      { to: e.to },
      t(
        m,
        {
          appear: !0,
          name: "nt-dialog"
        },
        {
          default: () => e.modelValue ? t(
            r,
            {
              shadowClass: [
                "nt-dialog",
                e.alignCenter ? "nt-dialog-align-center" : ""
              ].join(" ").trim(),
              transparent: !e.mask,
              onShadowClick: i
            },
            {
              default: () => {
                const l = [
                  t(
                    "header",
                    {
                      class: "nt-dialog-header"
                    },
                    a.header != null ? a.header() : e.title
                  )
                ];
                return e.showClose !== 0 && l.push(
                  t(
                    n,
                    {
                      circle: !0,
                      type: "normal",
                      class: `nt-dialog-close${e.showClose}`,
                      onClick: () => o("close")
                    },
                    {
                      default: () => t(h)
                    }
                  )
                ), l.push(
                  t(
                    "div",
                    {
                      class: [
                        "nt-dialog-container",
                        e.containerClass
                      ]
                    },
                    a.default != null ? a.default() : void 0
                  )
                ), l.push(
                  t(
                    "footer",
                    { class: "nt-dialog-footer" },
                    a.footer ? a.footer() : [
                      e.showCancel ? t(
                        n,
                        {
                          type: "normal",
                          text: e.theme === "mobile",
                          onClick: () => o("close")
                        },
                        { default: () => "取消" }
                      ) : void 0,
                      e.showOk ? t(
                        n,
                        {
                          type: "primary",
                          text: e.theme === "mobile",
                          onClick: () => o("ok")
                        },
                        { default: () => "确定" }
                      ) : void 0
                    ]
                  )
                ), t(
                  "div",
                  {
                    class: [
                      "nt-dialog-main",
                      "nt-dialog-" + e.theme,
                      e.mainClass
                    ],
                    style: {
                      width: e.width ? e.width : void 0
                    }
                  },
                  l
                );
              }
            }
          ) : null
        }
      )
    );
  }
});
export {
  k as _
};
