import { defineComponent as P, ref as k, watch as W, provide as R, openBlock as x, createElementBlock as B, normalizeClass as C, normalizeStyle as E, renderSlot as M } from "vue";
import { b as $, f as A } from "./constant-IdVoXVxo.js";
const b = {
  mobile: "请输入正确的手机号",
  same: "两次输入不一致",
  required: "%s为必填字段"
}, v = "请输入正确的数据", m = {
  /** 验证跟其余数据相等的正则，一般用于验证再次输入密码 */
  same: /^same:(.+)$/i,
  /** 验证手机号的正则表达式 */
  mobile: /^1[345678]\d{9}$/,
  /** 非空验证的正则表达式 */
  required: /^\S{1}.*/
}, g = {
  /** 验证相等 */
  same(d, i) {
    return i === d;
  },
  /** 正则匹配 */
  pattern(d, i) {
    return i == null ? !1 : d.test(String(i));
  }
};
class _ extends Error {
  constructor(i, t) {
    super(t), this.name = "ValidateError", this.key = i;
  }
}
class F {
  /**
   * 构造数据验证转换器
   *
   * See {@link https://gitee.com/towardly/ph/wikis/utils/validator|Validator文档}.
   *
   * @param schemas 配置验证转换规则
   *
   * @example
   *
   * const validator = new Validator([
   *  { key: 'mobile', rules: ['required', 'mobile'] },
   *  { key: 'code': rules: /^\d{6}$/, message: '请输入正确的验证码' },
   *  { key: 'confirmPassword', rules: ['required', 'same:password'] }
   * ])
   * // 验证某一个字段
   * validator.validateKey().then(res => {})
   */
  constructor(i) {
    let t = {};
    for (let l of i) {
      let s = [], e = l.rules;
      if (e != null)
        if (typeof e == "string")
          s = s.concat(this._parseStringRule(e, l.message));
        else if (e instanceof Array)
          for (let a of e)
            typeof a == "string" ? s.push(...this._parseStringRule(a, l.message)) : a instanceof RegExp || typeof a == "function" ? s.push({
              rule: a,
              message: l.message || v
            }) : typeof a.rule == "string" ? s.push(...this._parseStringRule(a.rule, a.message)) : s.push({
              rule: a.rule,
              message: a.message || v
            });
        else
          s.push({ rule: e, message: v });
      l.required === !0 && (s == null || s.findIndex((a) => a.rule === "required") === -1) && s.push(...this._parseStringRule("required", l.message)), t[l.key] = s;
    }
    this.rules = t;
  }
  /**
   * 进行数据验证
   * @param data 待验证的数据
   * @returns
   */
  async validate(i) {
    let t = "", l = "";
    for (let s in this.rules)
      if (this.rules.hasOwnProperty(s) && (t = this._validateRule(this.rules[s], i[s], i), t !== "")) {
        l = s, t = t.replace("%s", s);
        break;
      }
    if (t === "")
      return !0;
    throw new _(l, t);
  }
  /**
   * 只验证指定 key 的数据格式
   * @param key   指定待验证的 key
   * @param value 待验证的数据
   * @param data 原始数据，当验证确认密码时需要使用
   */
  async validateKey(i, t, l) {
    let s = this.rules[i], e = this._validateRule(s, t, l);
    if (e !== "")
      throw e = e.replace("%s", i), new _(i, e);
    return { key: i, value: t };
  }
  _validateRule(i, t, l) {
    let s = "";
    for (let e of i)
      if (e.rule === "required" && (t == null || !g.pattern(m.required, t)) && (s = e.message), typeof e.rule == "function" ? e.rule(t) || (s = e.message) : e.sameKey != null ? l != null && (g.same(t, l[e.sameKey]) || (s = e.message)) : e.rule === "required" ? g.pattern(m.required, String(t)) || (s = e.message) : g.pattern(e.rule, String(t)) || (s = e.message), s !== "")
        break;
    return s;
  }
  _parseStringRule(i, t) {
    let l = [], s = i.split("|");
    for (let e of s) {
      let a = t, n = null, c;
      if (m.same.test(e)) {
        if (e.match(m.same) != null) {
          n = m.same;
          let p = e.match(m.same);
          p != null && (c = p[1]), a = a || b.same;
        }
      } else i === "required" ? (n = "required", a = a || t || b.required) : m.hasOwnProperty(e) && (n = m[e], a = a || b[e]);
      l.push({ rule: n, message: a, sameKey: c });
    }
    return l;
  }
}
const D = /* @__PURE__ */ P({
  __name: "Form",
  props: {
    model: {},
    labelWidth: {},
    rules: {},
    inline: { type: Boolean, default: !1 },
    disabled: { type: Boolean, default: !1 },
    labelPosition: { default: "right" }
  },
  emits: ["submit"],
  setup(d, { expose: i, emit: t }) {
    const l = d, s = t, e = k({}), a = k([]);
    let n = null;
    l.rules != null && (a.value = l.rules.reduce((r, u) => {
      var o;
      return (u.required || (o = u.rules) != null && o.includes("required")) && r.push(u.key), r;
    }, []), n = new F(l.rules));
    let c = [];
    if (l.model != null && n != null) {
      const r = [];
      for (const u in l.model)
        c.push(u), r.push(() => l.model[u]);
      r.length > 0 && W(r, (u, o) => {
        if (n != null)
          for (let f = 0, y = u.length; f < y; f++) {
            const h = u[f];
            h !== o[f] && n.validateKey(c[f], h, l.model).then(() => {
              e.value[c[f]] = void 0;
            }).catch((S) => {
              e.value[S.key] = S.message;
            });
          }
      });
    }
    R($, {
      /** 错误信息 */
      errors: e,
      /** 必填字段列表 */
      requiredKeys: a,
      labelWidth: () => l.labelWidth,
      labelPosition: () => l.labelPosition
    }), R(A, () => l.disabled);
    function q(r) {
      r.preventDefault(), n != null ? p() : s("submit");
    }
    function p() {
      n != null && l.model != null && n.validate(l.model).then(() => {
        e.value = {}, s("submit");
      }).catch((r) => {
        e.value = {
          [r.key]: r.message
        };
      });
    }
    function w(r) {
      if (n != null && l.model != null) {
        const u = [];
        if (Array.isArray(r))
          for (let o = 0, f = r.length; o < f; o++)
            u.push(
              n.validateKey(r[o], l.model[r[o]], l.model)
            );
        else
          u.push(n.validateKey(r, l.model[r], l.model));
        Promise.allSettled(u).then((o) => {
          for (let f = 0, y = o.length; f < y; f++) {
            const h = o[f];
            h.status === "rejected" ? e.value[h.reason.key] = h.reason.message : e.value[h.value.key] = void 0;
          }
        });
      }
    }
    function K() {
      e.value = {};
    }
    return i({
      validate: p,
      validateField: w,
      clearValidate: K
    }), (r, u) => (x(), B("form", {
      class: C([
        "nt-form",
        r.inline ? "nt-form-inline" : void 0,
        `nt-form--${r.labelPosition}`
      ]),
      onSubmit: q,
      style: E({
        "--nt-form-label-width": r.labelWidth ? r.labelWidth : void 0
      })
    }, [
      M(r.$slots, "default")
    ], 38));
  }
});
export {
  D as _
};
