import { PropType, VNode } from 'vue';
type SelectOption = {
    class?: string;
    render?: (option: SelectOption, isSelect: boolean, selectedValues?: any | any[]) => VNode[] | VNode;
    label?: string;
    value?: any;
    [index: string]: any;
};
declare const _default: import('vue').DefineComponent<import('vue').ExtractPropTypes<{
    /** 提示信息 */
    placeholder: {
        type: StringConstructor;
        default: string;
    };
    /** 是否禁用 */
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 选项 label 的字段名 */
    labelField: {
        type: StringConstructor;
        default: string;
    };
    /** 选项 value 的字段名 */
    valueField: {
        type: StringConstructor;
        default: string;
    };
    /** 配置选项内容 */
    options: {
        type: PropType<SelectOption[]>;
        default: () => never[];
    };
    /** 是否多选 */
    multiple: {
        type: BooleanConstructor;
        default: boolean;
    };
    modelValue: {
        type: PropType<any | any[]>;
    };
    /** 多选时是否将选中值按文字的形式展示 */
    collapseTags: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否可清空 */
    clearable: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否启用过滤 */
    filterable: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 自定义过滤函数 */
    filter: {
        type: PropType<(match: string, option: SelectOption) => boolean>;
    };
    /** 是否启用远程搜索 */
    remote: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否为加载状态, 通常为远程搜索时使用 */
    loading: {
        type: BooleanConstructor;
        default: boolean;
    };
}>, () => VNode<import('vue').RendererNode, import('vue').RendererElement, {
    [key: string]: any;
}>[], {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, ("search" | "update:modelValue")[], "search" | "update:modelValue", import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<{
    /** 提示信息 */
    placeholder: {
        type: StringConstructor;
        default: string;
    };
    /** 是否禁用 */
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 选项 label 的字段名 */
    labelField: {
        type: StringConstructor;
        default: string;
    };
    /** 选项 value 的字段名 */
    valueField: {
        type: StringConstructor;
        default: string;
    };
    /** 配置选项内容 */
    options: {
        type: PropType<SelectOption[]>;
        default: () => never[];
    };
    /** 是否多选 */
    multiple: {
        type: BooleanConstructor;
        default: boolean;
    };
    modelValue: {
        type: PropType<any | any[]>;
    };
    /** 多选时是否将选中值按文字的形式展示 */
    collapseTags: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否可清空 */
    clearable: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否启用过滤 */
    filterable: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 自定义过滤函数 */
    filter: {
        type: PropType<(match: string, option: SelectOption) => boolean>;
    };
    /** 是否启用远程搜索 */
    remote: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否为加载状态, 通常为远程搜索时使用 */
    loading: {
        type: BooleanConstructor;
        default: boolean;
    };
}>> & Readonly<{
    "onUpdate:modelValue"?: ((...args: any[]) => any) | undefined;
    onSearch?: ((...args: any[]) => any) | undefined;
}>, {
    disabled: boolean;
    loading: boolean;
    placeholder: string;
    multiple: boolean;
    options: SelectOption[];
    labelField: string;
    valueField: string;
    collapseTags: boolean;
    clearable: boolean;
    filterable: boolean;
    remote: boolean;
}, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
export default _default;
