import { PropType, VNode } from 'vue';
declare const _default: import('vue').DefineComponent<import('vue').ExtractPropTypes<{
    /** 控制遮罩展现，是否显示遮罩 */
    mask: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否可以通过点击 mask 关闭对话框 */
    maskClosable: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否显示对话框 */
    modelValue: {
        type: BooleanConstructor;
        default: boolean;
        required: true;
    };
    /** Dialog 对话框 Dialog 的标题， 也可通过具名 slot （见下表）传入
     * 如果都不传，则不显示标题
     */
    title: StringConstructor;
    /** 是否显示右上角关闭按钮, 1 - 显示在框内， 2 - 显示在框角, 0 - 不显示 */
    showClose: {
        type: PropType<1 | 2 | 0>;
        default: number;
    };
    /** 是否显示底部取消按钮 */
    showCancel: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否显示底部确定按钮 */
    showOk: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 主体样式 */
    mainClass: {
        type: StringConstructor;
        default: string;
    };
    /** 内容区域样式 */
    containerClass: {
        type: StringConstructor;
        default: string;
    };
    /** 是否水平垂直对齐对话框 */
    alignCenter: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 关闭前的回调, 会暂停 Dialog 的关闭. */
    beforeClose: {
        type: PropType<(type: "cancel" | "ok" | "close", done: () => void) => void>;
        default: undefined;
    };
    /** 对话框宽度 */
    width: {
        type: StringConstructor;
        default: undefined;
    };
    to: {
        type: PropType<HTMLElement | "string">;
        default: string;
    };
    /** 主题, normal - 普通, mobile - 移动风格 */
    theme: {
        type: PropType<"normal" | "mobile">;
        default: string;
    };
}>, () => VNode<import('vue').RendererNode, import('vue').RendererElement, {
    [key: string]: any;
}>, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, "update:modelValue"[], "update:modelValue", import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<{
    /** 控制遮罩展现，是否显示遮罩 */
    mask: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否可以通过点击 mask 关闭对话框 */
    maskClosable: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否显示对话框 */
    modelValue: {
        type: BooleanConstructor;
        default: boolean;
        required: true;
    };
    /** Dialog 对话框 Dialog 的标题， 也可通过具名 slot （见下表）传入
     * 如果都不传，则不显示标题
     */
    title: StringConstructor;
    /** 是否显示右上角关闭按钮, 1 - 显示在框内， 2 - 显示在框角, 0 - 不显示 */
    showClose: {
        type: PropType<1 | 2 | 0>;
        default: number;
    };
    /** 是否显示底部取消按钮 */
    showCancel: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否显示底部确定按钮 */
    showOk: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 主体样式 */
    mainClass: {
        type: StringConstructor;
        default: string;
    };
    /** 内容区域样式 */
    containerClass: {
        type: StringConstructor;
        default: string;
    };
    /** 是否水平垂直对齐对话框 */
    alignCenter: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 关闭前的回调, 会暂停 Dialog 的关闭. */
    beforeClose: {
        type: PropType<(type: "cancel" | "ok" | "close", done: () => void) => void>;
        default: undefined;
    };
    /** 对话框宽度 */
    width: {
        type: StringConstructor;
        default: undefined;
    };
    to: {
        type: PropType<HTMLElement | "string">;
        default: string;
    };
    /** 主题, normal - 普通, mobile - 移动风格 */
    theme: {
        type: PropType<"normal" | "mobile">;
        default: string;
    };
}>> & Readonly<{
    "onUpdate:modelValue"?: ((...args: any[]) => any) | undefined;
}>, {
    mask: boolean;
    to: "string" | HTMLElement;
    width: string;
    maskClosable: boolean;
    showClose: 0 | 1 | 2;
    showCancel: boolean;
    showOk: boolean;
    mainClass: string;
    containerClass: string;
    alignCenter: boolean;
    beforeClose: (type: "cancel" | "ok" | "close", done: () => void) => void;
    theme: "normal" | "mobile";
}, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
export default _default;
