import { PropType, Ref } from 'vue';
export declare const popoverProps: {
    /** 触发方式: hover - 渲染, click - 点击, manual - 非受控模式, 手动展开 */
    trigger: {
        type: PropType<"hover" | "click" | "focus" | "manual">;
        default: string;
    };
    /** 显示的内容，也可以通过写入默认 slot 修改显示内容 */
    content: StringConstructor;
    /** 弹出位置 */
    placement: {
        type: PropType<"top-start" | "top" | "top-end" | "bottom-start" | "bottom" | "bottom-end" | "left" | "left-start" | "left-end" | "right" | "right-start" | "right-end">;
        default: string;
    };
    /** 受控模式时对应的节点 */
    reference: PropType<HTMLElement | string | Ref<HTMLElement>>;
    /** 是否显示箭头 */
    showArrow: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否不能激活弹出信息 */
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 宽度, 'trigger' 表示 popover 的宽度会和它的触发元素一致 */
    width: {
        type: PropType<number | "trigger">;
        default: undefined;
    };
    /** 浮层偏移量 */
    offset: {
        type: NumberConstructor;
        default: number;
    };
    /** 是否在隐藏时删除节点, 如果为 true 则删除, 否则只是设置 display: none */
    destroyOnHide: {
        type: BooleanConstructor;
        default: boolean;
    };
};
