import { PropType, VNode, CSSProperties } from 'vue';
export interface ColumnOption {
    /** 排序时，如果传递了 key，则会将此 key 回传，便于排序, 如果不传此 key，则排序无效 */
    key?: string;
    /** 文本 */
    title?: string;
    /** 是否启用排序 */
    sorter?: boolean;
    /** 是否固定列 */
    fixed?: 'left' | 'right';
    /** 列宽 */
    width?: string | number;
    /** 单元格内容渲染函数 */
    render?: (row: any, index: number) => VNode | VNode[];
    /** 表头分组配置 */
    children?: ColumnOption[];
    /** td colspan */
    colspan?: number | ((rowData: any, rowIndex: number) => number);
    /** td rowspan */
    rowspan?: number | ((rowData: any, rowIndex: number) => number);
    /** th colspan */
    titleColspan?: number;
    /** th rowspan */
    titleRowspan?: number;
    id?: string;
    style?: CSSProperties;
    class?: string;
}
export interface DataSortState {
    key: string;
    index: number;
    order: 'asc' | 'desc';
}
interface SortOption {
    key: string;
    order: string;
}
type SorterFnOption = (data: any[], sortInfo: {
    order: string;
    key: string;
}) => any[];
type RowKeyOption = (row: any) => any;
declare const _default: import('vue').DefineComponent<import('vue').ExtractPropTypes<{
    columns: {
        type: PropType<ColumnOption[]>;
        required: true;
    };
    /** 创建带斑马纹的表格 */
    stripe: {
        type: BooleanConstructor;
        default: boolean;
        required: false;
    };
    /** 是否显示四周边框 */
    border: {
        type: BooleanConstructor;
        default: boolean;
        required: false;
    };
    /** 是否固定表头 */
    fixedHead: {
        type: BooleanConstructor;
        default: boolean;
        required: false;
    };
    data: {
        type: PropType<any[]>;
        required: true;
    };
    defaultSort: {
        type: PropType<SortOption>;
        required: false;
    };
    sorter: {
        type: PropType<SorterFnOption>;
        required: false;
    };
    /** 渲染表尾合计行 */
    renderSummary: {
        type: PropType<() => VNode | VNode[]>;
        required: false;
    };
    /** 是否使用 fixed[table-layout:fixed] 布局 */
    tableLayout: {
        type: StringConstructor;
        required: false;
        default: string;
    };
    rowKey: {
        type: PropType<RowKeyOption>;
        required: false;
    };
}>, () => VNode<import('vue').RendererNode, import('vue').RendererElement, {
    [key: string]: any;
}>, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, "select-change"[], "select-change", import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<{
    columns: {
        type: PropType<ColumnOption[]>;
        required: true;
    };
    /** 创建带斑马纹的表格 */
    stripe: {
        type: BooleanConstructor;
        default: boolean;
        required: false;
    };
    /** 是否显示四周边框 */
    border: {
        type: BooleanConstructor;
        default: boolean;
        required: false;
    };
    /** 是否固定表头 */
    fixedHead: {
        type: BooleanConstructor;
        default: boolean;
        required: false;
    };
    data: {
        type: PropType<any[]>;
        required: true;
    };
    defaultSort: {
        type: PropType<SortOption>;
        required: false;
    };
    sorter: {
        type: PropType<SorterFnOption>;
        required: false;
    };
    /** 渲染表尾合计行 */
    renderSummary: {
        type: PropType<() => VNode | VNode[]>;
        required: false;
    };
    /** 是否使用 fixed[table-layout:fixed] 布局 */
    tableLayout: {
        type: StringConstructor;
        required: false;
        default: string;
    };
    rowKey: {
        type: PropType<RowKeyOption>;
        required: false;
    };
}>> & Readonly<{
    "onSelect-change"?: ((...args: any[]) => any) | undefined;
}>, {
    stripe: boolean;
    border: boolean;
    fixedHead: boolean;
    tableLayout: string;
}, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
export default _default;
