import { CellContext, ColumnDef, Table, ColumnSort } from '@tanstack/vue-table';
import { VNode } from 'vue';
export type ColumnDict<T> = {
    id?: string;
    /** 标题 */
    title?: string;
    /** 标题 */
    header?: string | ((opts: {
        table: Table<T>;
    }) => VNode | string);
    key?: string;
    accessorKey?: string;
    cell?: (row: T, index: number, info: CellContext<T, unknown>) => VNode | VNode[] | string;
    /** 列宽 */
    size?: number;
    fixed?: 'left' | 'right';
    /** 设置列为可选择 */
    type?: 'selection';
    /** 排序 */
    sorter?: boolean | ((rowA: T, rowB: T) => number);
    columns?: ColumnDict<T>[];
};
export type ColumnOption<T> = ColumnDict<T> & ColumnDef<T>;
declare const _default: <T>(__VLS_props: NonNullable<Awaited<typeof __VLS_setup>>["props"], __VLS_ctx?: __VLS_PrettifyLocal<Pick<NonNullable<Awaited<typeof __VLS_setup>>, "attrs" | "emit" | "slots">>, __VLS_expose?: NonNullable<Awaited<typeof __VLS_setup>>["expose"], __VLS_setup?: Promise<{
    props: __VLS_PrettifyLocal<Pick<Partial<{}> & Omit<{} & import('vue').VNodeProps & import('vue').AllowedComponentProps & import('vue').ComponentCustomProps, never>, never> & {
        stripe?: boolean;
        border?: boolean;
        tableLayout?: "auto" | "fixed";
        columns: Array<ColumnOption<T>>;
        data: Array<T>;
        fixedHead?: boolean;
        multiSelection?: boolean;
        /** 默认排序 */
        defaultSorter?: ColumnSort;
        /** 配置展开属性  */
        expandable?: {
            /** 设置是否允许行展开 */
            rowExpandable: (row: T) => boolean;
            /** 展开行渲染内容 */
            expandedRowRender: (row: T) => VNode | VNode[];
        };
    }> & import('vue').PublicProps;
    expose(exposed: import('vue').ShallowUnwrapRef<{}>): void;
    attrs: any;
    slots: {};
    emit: {};
}>) => VNode<import('vue').RendererNode, import('vue').RendererElement, {
    [key: string]: any;
}> & {
    __ctx?: Awaited<typeof __VLS_setup>;
};
export default _default;
type __VLS_PrettifyLocal<T> = {
    [K in keyof T]: T[K];
} & {};
