import { DirectiveBinding, Ref } from 'vue';
interface LoadingInstanceOption {
    fullscreen?: boolean;
    unlock?: boolean;
    bar?: boolean;
    to?: string | HTMLElement | Ref<HTMLElement> | null;
    text?: string;
    background?: string;
}
declare class LoadingInstance {
    /** 加载条节点 */
    el: HTMLElement;
    option: Required<Omit<LoadingInstanceOption, 'to'>>;
    /**
     * 构建加载条
     * @param to 加载条挂载位置, 不传则挂载到 body
     */
    constructor(option?: LoadingInstanceOption);
    close(): void;
}
declare const LoadingDirective: {
    (el: HTMLElement, binding: DirectiveBinding): void;
    open(option?: LoadingInstanceOption): LoadingInstance;
};
export default LoadingDirective;
